﻿// DataGridWebApplication: Demonstrates how easily can GridView be populated with data read from OPC Data Access server.

using System;
using System.Collections.Generic;
using OpcLabs.BaseLib.OperationModel;
using OpcLabs.EasyOpc.DataAccess;

namespace DataGridWebApplication
{
    // ReSharper disable InconsistentNaming
    public partial class _Default : System.Web.UI.Page
    // ReSharper restore InconsistentNaming
    {
        class Row
        {
            // ReSharper disable UnusedAutoPropertyAccessor.Local
            public string ItemId { get; set; }
            public string Value { get; set; }
            // ReSharper restore UnusedAutoPropertyAccessor.Local
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            var client = new EasyDAClient();
            var itemDescriptors = new DAItemDescriptor[]
                {
                    "Simulation.Register_BOOL",
                    "Simulation.Register_I2",
                    "Demo.Ramp",
                    "Demo.Single"                                                         
                };

            ValueResult[] valueResults = client.ReadMultipleItemValues("OPCLabs.KitServer.2", itemDescriptors);

            var data = new List<Row>();
            // ReSharper disable once LoopCanBeConvertedToQuery
            for (int i = 0; i < itemDescriptors.Length; i++)
                data.Add(new Row
                    {
                        // ReSharper disable once PossibleNullReferenceException
                        ItemId = itemDescriptors[i].ItemId, 
                        // ReSharper disable PossibleNullReferenceException
                        Value = valueResults[i].Value.ToString()
                        // ReSharper restore PossibleNullReferenceException
                    });

            GridView1.DataSource = data;
            GridView1.DataBind();
        }
    }
}
